Index: trunk/SophyaLib/Manual/piahelp.tex
===================================================================
--- trunk/SophyaLib/Manual/piahelp.tex	(revision 2548)
+++ trunk/SophyaLib/Manual/piahelp.tex	(revision 2811)
@@ -27,9 +27,9 @@
 \vspace{3mm} 
 \begin{tabular}{llllll}  
-Commander & p. \pageref{Commander}  & ObjectExpressions & p. \pageref{ObjectExpressions}  & PIConsole & p. \pageref{PIConsole}  \\  
-PIDraw3DWdg & p. \pageref{PIDraw3DWdg}  & PIImage & p. \pageref{PIImage}  & PIScDrawWdg & p. \pageref{PIScDrawWdg}  \\  
-RPNEvaluator & p. \pageref{RPNEvaluator}  & Windows & p. \pageref{Windows}  & autoiniranf & p. \pageref{autoiniranf}  \\  
-exitpiapp & p. \pageref{exitpiapp}  & helpfit & p. \pageref{helpfit}  & helpwindow & p. \pageref{helpwindow}  \\  
-shell execute & p. \pageref{shellZexecute}  &   &  &  &   \\  
+CExpEvaluator & p. \pageref{CExpEvaluator}  & Commander & p. \pageref{Commander}  & ObjectExpressions & p. \pageref{ObjectExpressions}  \\  
+PIConsole & p. \pageref{PIConsole}  & PIDraw3DWdg & p. \pageref{PIDraw3DWdg}  & PIImage & p. \pageref{PIImage}  \\  
+PIScDrawWdg & p. \pageref{PIScDrawWdg}  & RPNEvaluator & p. \pageref{RPNEvaluator}  & Windows & p. \pageref{Windows}  \\  
+autoiniranf & p. \pageref{autoiniranf}  & exitpiapp & p. \pageref{exitpiapp}  & helpfit & p. \pageref{helpfit}  \\  
+helpwindow & p. \pageref{helpwindow}  & shell execute & p. \pageref{shellZexecute}  & stop & p. \pageref{stop}  \\  
 \end{tabular} 
 \end{center} 
@@ -40,6 +40,6 @@
 \vspace{3mm} 
 \begin{tabular}{llllll} 
-Commander & p. \pageref{Commander}  & RPNEvaluator & p. \pageref{RPNEvaluator}  & autoiniranf & p. \pageref{autoiniranf}  \\  
-shell execute & p. \pageref{shellZexecute}  &   &  &  &   \\  
+CExpEvaluator & p. \pageref{CExpEvaluator}  & Commander & p. \pageref{Commander}  & RPNEvaluator & p. \pageref{RPNEvaluator}  \\  
+autoiniranf & p. \pageref{autoiniranf}  & shell execute & p. \pageref{shellZexecute}  &   &   \\  
 \end{tabular} 
 \end{center} 
@@ -94,5 +94,6 @@
 ntfrascii & p. \pageref{ntfrascii}  & openfits & p. \pageref{openfits}  & openppf & p. \pageref{openppf}  \\  
 print & p. \pageref{print}  & saveall & p. \pageref{saveall}  & savefits & p. \pageref{savefits}  \\  
-saveobjs & p. \pageref{saveobjs}  & saveppf & p. \pageref{saveppf}  & vecfrascii & p. \pageref{vecfrascii}  \\  
+savelist & p. \pageref{savelist}  & saveobjs & p. \pageref{saveobjs}  & saveppf & p. \pageref{saveppf}  \\  
+vecfrascii & p. \pageref{vecfrascii}  &   &  &  &   \\  
 \end{tabular} 
 \end{center} 
@@ -122,7 +123,8 @@
 addarc & p. \pageref{addarc}  & addarca & p. \pageref{addarca}  & addarrow & p. \pageref{addarrow}  \\  
 addcirc & p. \pageref{addcirc}  & addctext & p. \pageref{addctext}  & addfarc & p. \pageref{addfarc}  \\  
-addfarca & p. \pageref{addfarca}  & addfcirc & p. \pageref{addfcirc}  & addfpoly & p. \pageref{addfpoly}  \\  
-addfrect & p. \pageref{addfrect}  & addline & p. \pageref{addline}  & addmarker & p. \pageref{addmarker}  \\  
-addpoly & p. \pageref{addpoly}  & addrect & p. \pageref{addrect}  & addtext & p. \pageref{addtext}  \\  
+addfarca & p. \pageref{addfarca}  & addfcirc & p. \pageref{addfcirc}  & addfoval & p. \pageref{addfoval}  \\  
+addfpoly & p. \pageref{addfpoly}  & addfrect & p. \pageref{addfrect}  & addline & p. \pageref{addline}  \\  
+addmarker & p. \pageref{addmarker}  & addoval & p. \pageref{addoval}  & addpoly & p. \pageref{addpoly}  \\  
+addrect & p. \pageref{addrect}  & addtext & p. \pageref{addtext}  &   &   \\  
 \end{tabular} 
 \end{center} 
@@ -147,8 +149,9 @@
 \vspace{3mm} 
 \begin{tabular}{llllll} 
-contour & p. \pageref{contour}  & disp & p. \pageref{disp}  & gfd2d & p. \pageref{gfd2d}  \\  
-gfd3d & p. \pageref{gfd3d}  & imag & p. \pageref{imag}  & nt2d & p. \pageref{nt2d}  \\  
-nt2dvec & p. \pageref{nt2dvec}  & nt3d & p. \pageref{nt3d}  & ntcont & p. \pageref{ntcont}  \\  
-surf & p. \pageref{surf}  & vecplot & p. \pageref{vecplot}  &   &   \\  
+bargraph & p. \pageref{bargraph}  & contour & p. \pageref{contour}  & disp & p. \pageref{disp}  \\  
+gfd2d & p. \pageref{gfd2d}  & gfd3d & p. \pageref{gfd3d}  & imag & p. \pageref{imag}  \\  
+imagnav & p. \pageref{imagnav}  & nt2d & p. \pageref{nt2d}  & nt2dvec & p. \pageref{nt2dvec}  \\  
+nt3d & p. \pageref{nt3d}  & ntcont & p. \pageref{ntcont}  & surf & p. \pageref{surf}  \\  
+textdrawer & p. \pageref{textdrawer}  & vecplot & p. \pageref{vecplot}  &   &   \\  
 \end{tabular} 
 \end{center} 
@@ -170,9 +173,9 @@
 \vspace{3mm} 
 \begin{tabular}{llllll} 
-line2nt & p. \pageref{line2nt}  & line2vec & p. \pageref{line2vec}  & newgfd & p. \pageref{newgfd}  \\  
-newh1d & p. \pageref{newh1d}  & newh2d & p. \pageref{newh2d}  & newmtx & p. \pageref{newmtx}  \\  
-newnt & p. \pageref{newnt}  & newprof & p. \pageref{newprof}  & newprofe & p. \pageref{newprofe}  \\  
-newvec & p. \pageref{newvec}  & ntcol2var & p. \pageref{ntcol2var}  & ntline2var & p. \pageref{ntline2var}  \\  
-vec2var & p. \pageref{vec2var}  &   &  &  &   \\  
+line2nt & p. \pageref{line2nt}  & line2vec & p. \pageref{line2vec}  & newdt & p. \pageref{newdt}  \\  
+newgfd & p. \pageref{newgfd}  & newh1d & p. \pageref{newh1d}  & newh2d & p. \pageref{newh2d}  \\  
+newmtx & p. \pageref{newmtx}  & newnt & p. \pageref{newnt}  & newprof & p. \pageref{newprof}  \\  
+newprofe & p. \pageref{newprofe}  & newvec & p. \pageref{newvec}  & ntcol2var & p. \pageref{ntcol2var}  \\  
+ntline2var & p. \pageref{ntline2var}  & vec2var & p. \pageref{vec2var}  &   &   \\  
 \end{tabular} 
 \end{center} 
@@ -182,5 +185,5 @@
 \vspace{3mm} 
 \begin{tabular}{llllll} 
-exitpiapp & p. \pageref{exitpiapp}  & helpwindow & p. \pageref{helpwindow}  &   &   \\  
+exitpiapp & p. \pageref{exitpiapp}  & helpwindow & p. \pageref{helpwindow}  & stop & p. \pageref{stop}  \\  
 \end{tabular} 
 \end{center} 
@@ -206,4 +209,5 @@
 \begin{tabular}{llllll} 
 mollgrid & p. \pageref{mollgrid}  & mollgridsph & p. \pageref{mollgridsph}  & powerspec & p. \pageref{powerspec}  \\  
+setprjmoldefval & p. \pageref{setprjmoldefval}  &   &  &  &   \\  
 \end{tabular} 
 \end{center} 
@@ -217,7 +221,8 @@
 h/integ & p. \pageref{hZinteg}  & h/oper & p. \pageref{hZoper}  & h/plot/2d & p. \pageref{hZplotZ2d}  \\  
 h/put\_vec & p. \pageref{hZputZvec}  & h/rebin & p. \pageref{hZrebin}  & h/set/cont & p. \pageref{hZsetZcont}  \\  
-h/set/err & p. \pageref{hZsetZerr}  & n/plot & p. \pageref{nZplot}  & n/proj & p. \pageref{nZproj}  \\  
+h/set/err & p. \pageref{hZsetZerr}  & n/merge & p. \pageref{nZmerge}  & n/pl & p. \pageref{nZpl}  \\  
+n/plot & p. \pageref{nZplot}  & n/proj & p. \pageref{nZproj}  & n/read & p. \pageref{nZread}  \\  
 n/scan & p. \pageref{nZscan}  & reset & p. \pageref{reset}  & v/deriv & p. \pageref{vZderiv}  \\  
-v/integ & p. \pageref{vZinteg}  &   &  &  &   \\  
+v/integ & p. \pageref{vZinteg}  & v/sort & p. \pageref{vZsort}  &   &   \\  
 \end{tabular} 
 \end{center} 
@@ -227,21 +232,31 @@
 Basic (generic) interpreter (class SOPHYA::Commander) builtin commands 
  \\[2mm]  \noindent 
+\piahelpitem{CExpEvaluator} \label{CExpEvaluator} 
+\begin{verbatim} 
+> Evaluation of C-like expression (used in V = C-like-Expression) 
+   >>> Arithmetic operators, parenthesis ( + - * / ) 
+   >>> Functions : sqrt fabs floor hypot 
+   ...  exp log log10 pow  ; sinh cosh tanh 
+   ...  sin cos tan asin acos atan atan2  
+   ...  rand01()  randpm1() gaurand() 
+   >>> Constants : Pi = M_PI E = M_E 
+   Example: x = 5.*(2.+sin(0.3*Pi))
+\end{verbatim} 
 \piahelpitem{Commander} \label{Commander} 
 \begin{verbatim} 
 >>> (Commander) Interpreter's keywords : 
-  > set varname string   # To set a variable, $varname 
-  > get newvarname varname # To set a newvariable, equal to $varname 
-  > setol varname patt     # Fills varname with object list 
+  > set varname string     # To set a variable, $varname 
   > unset varname          # clear variable definition 
-  > rpneval varname RPNExpression # Reverse Polish Notation evaluation 
-  > varname = 'string string ...' # To set a variable, $varname  
-  > varname = RPNExpression # RPN evaluation / result -> varname 
+  > rpneval varname RPNExpression  # Reverse Polish Notation evaluation 
+  > varname = ArithmeticExpression # C-like Expression evaluation   
+  > varname = 'String'     # Set variable vname  
+  > var2words varname wordvarname [sep]    # to break varname into words  
   > echo string            # output string 
   > echo2file filename string # Append the string to the specified file 
   > alias name string      # define a command alias 
-  > readstdin varname      # reads a line from stdin into $varname 
   > foreach varname ( string-list ) # Loop 
   > for varname i1:i2[:di]      # Integer loop  
   > for varname f1:f2[:df]      # Float loop  
+  > forinfile varname FileName  # Loop over lines in file 
   > end                         # end loops 
   > if ( test ) then  # Conditional test : a == != < > <= >= b 
@@ -256,6 +271,12 @@
   > listscripts   # List of all known scripts 
   > clearcript    # Clear a script definition 
+  > thrlist       # List of command execution threads (& as the last character) 
+  > clearthrlist  # Removes finished threads from the list  
+  > cancelthr Id  # Cancel a given thread (ThrId=id)  
+  > waitthr       # Waits until all active threads have finished (join()) 
   > exec filename # Execute commands from file 
   > help <command_name>  # <command_name> usage info 
+  > sleep nsec  # sleep nsec seconds 
+  > readstdin varname      # reads a line from stdin into $varname 
   > timingon  timingoff traceon  traceoff 
 
@@ -615,5 +636,5 @@
 \piacommand{ntfrascii} \label{ntfrascii} 
 \begin{verbatim} 
-Fills an existing NTuple from ASCII table file
+Fills an existing NTuple or DataTable from ASCII table file
  Usage: ntfrascii nt_name file_name [def_init_val]
   Related commands: ntloop fillnt 
@@ -627,6 +648,6 @@
 \piacommand{openppf} \label{openppf} 
 \begin{verbatim} 
-Reads all objects from a PPF file 
- Usage: openppf filename
+Reads all or some objects from a PPF file 
+ Usage: openppf filename [objname1 objname2 ...]
   Related commands: saveall openfits
 \end{verbatim} 
@@ -640,5 +661,5 @@
 Saves all objects into a PPF file 
  Usage: saveall filename
-  Related commands: saveobj openppf savefits
+  Related commands: saveobj savelist openppf savefits
 \end{verbatim} 
 \piacommand{savefits} \label{savefits} 
@@ -648,4 +669,10 @@
   Related commands: openfits saveobjs saveall
 \end{verbatim} 
+\piacommand{savelist} \label{savelist} 
+\begin{verbatim} 
+
+ Usage: savelist objname1 [objname2 ...] filename
+  Related commands: saveobj openppf savefits
+\end{verbatim} 
 \piacommand{saveobjs} \label{saveobjs} 
 \begin{verbatim} 
@@ -653,5 +680,5 @@
   PPF file (pattern: x?y*) - Alias saveppf
 Usage: saveobjs nameobjpattern filename
-  Related commands: saveppf saveall openppf savefits
+  Related commands: saveppf savelist saveall openppf savefits
 \end{verbatim} 
 \piacommand{saveppf} \label{saveppf} 
@@ -660,5 +687,5 @@
   PPF file (pattern: x?y*) - Alias saveppf
 Usage: saveppf nameobjpattern filename
-  Related commands: saveobjs saveall openppf savefits
+  Related commands: saveobjs savelist saveall openppf savefits
 \end{verbatim} 
 \piacommand{vecfrascii} \label{vecfrascii} 
@@ -930,4 +957,15 @@
        addcirc addarc addfarc addpoly addfpoly graphicatt
 \end{verbatim} 
+\piacommand{addfoval} \label{addfoval} 
+\begin{verbatim} 
+Adds a filled oval (ellipse) to the current graphic object
+ centered on xc,yc - semi-axis ds,dy (+ graphic attribute)
+ The Base/AxesDrawer is used to handle added rectangle
+ Alt<E> to remove added element
+  Usage: addfoval xc yc dx dy [GraphicAtt] [fgnc=false/true]
+  if fgnc==true : Normalized 0..1 coordinates specification (def=false)
+  Related commands: addoval addline addarrow addfrect addcirc addfcirc
+       addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt
+\end{verbatim} 
 \piacommand{addfpoly} \label{addfpoly} 
 \begin{verbatim} 
@@ -970,4 +1008,15 @@
   if fgnc==true : Normalized 0..1 coordinates specification (def=false)
   Related commands: addtext addline addarrow addfrect addfrect
+       addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt
+\end{verbatim} 
+\piacommand{addoval} \label{addoval} 
+\begin{verbatim} 
+Adds an oval (ellipse) to the current graphic object
+ centered on xc,yc - semi-axis ds,dy (+ graphic attribute)
+ The Base/AxesDrawer is used to handle added rectangle
+ Alt<E> to remove added element
+  Usage: addoval xc yc dx dy [GraphicAtt] [fgnc=false/true]
+  if fgnc==true : Normalized 0..1 coordinates specification (def=false)
+  Related commands: addfoval addline addarrow addfrect addcirc addfcirc
        addcirc addfcirc addarc addfarc addpoly addfpoly graphicatt
 \end{verbatim} 
@@ -1043,6 +1092,9 @@
 >>>> Keyboard controls : 
 o <Alt>R : Resets the 3-D view and refreshes the display 
+o <Alt>O : Displays a specific control window (default: PIDrawerTools) 
+           (2-D histograms, contour plot ...) 
 o <Alt>G : Show the PIDrawerTools (Graphic attributes of displayed Drawers) 
-o <Alt>O : = <Alt>G 
+           Drawer 0 manages the axes, as well as the added text 
+o <Alt>D : Shows the drawer manipulation pop-up menu 
 o <Alt>V : Copy/Paste / Text paste at the current position (Drawer 0)
 o <Alt>Z : Removes added graphic elements (handled by BaseDrawer - 0) 
@@ -1065,4 +1117,5 @@
 o <Alt>O : Shows the PIImageTools (image display parameter controls) 
 o <Alt>G : Show the PIDrawerTools (Graphic attributes of overlayed graphics (Drawers)) 
+o <Alt>D : Shows the drawer manipulation pop-up menu 
 o <Alt>V : Copy/Paste / Text paste at the current cursor position 
 o <Alt>C : Copy/Paste / Copies the selected regions content as text in the copy/paste buffer 
@@ -1085,7 +1138,8 @@
 o <Alt>R : Refresh display 
 o <Alt>O : Displays a specific control window (default: PIDrawerTools) 
-           Specific controls for 2-D histograms 
+           (2-D histograms, contour plot ...) 
 o <Alt>G : Show the PIDrawerTools (Graphic attributes of displayed Drawers) 
            Drawer 0 manages the axes, as well as the added text 
+o <Alt>D : Shows the drawer manipulation pop-up menu 
 o <Alt>V : Copy/Paste / Text paste at the current position 
 o <Alt>Z : Removes added graphic elements (handled by BaseDrawer - 0) 
@@ -1137,45 +1191,53 @@
 \piacommand{graphicatt} \label{graphicatt} 
 \begin{verbatim} 
-To change default graphic options 
-  Usage: graphicatt att_list 
+To change default graphic options
+  Usage: graphicatt att_list
 att_list=def back to default values, Example: gratt 'red circlemarker5'
- ------------------ Graphic attribute list ------------------ 
->> Colors: defcol black white grey red blue green yellow 
-           magenta cyan turquoise navyblue orange siennared purple 
-           limegreen gold violet violetred blueviolet darkviolet 
->> Lines:  defline normalline thinline thickline dashedline thindashedline 
-           thickdashedline dottedline thindottedline thickdottedline 
->> Font Att: deffontatt normalfont boldfont italicfont bolditalicfont  
-             smallfont smallboldfont smallitalicfont smallbolditalicfont 
-             bigfont bigboldfont bigitalicfont bigbolditalicfont 
-             hugefont  hugeboldfont hugeitalicfont hugebolditalicfont 
->> Font Names: deffont courierfont helveticafont timesfont symbolfont  
->> Marker: dotmarker<T>  plusmarker<T>  crossmarker<T> circlemarker<T> 
-           fcirclemarker<T> boxmarker<T> fboxmarker<T> trianglemarker<T> 
-           ftrianglemarker<T>  starmarker<T>  fstarmarker<T> 
-   with <T> = 1 3 5 7 .. 15 , Example fboxmarker5 , plusmarker9 ... 
->> ArrowMarker: basicarrow<T>  trianglearrow<T>  ftrianglearrow<T> 
-                arrowshapedarrow<T> farrowshapedarrow<T> 
-   with <T> = 5 7 .. 15 , Example trianglearrow7 ... 
->> ColorTables: defcmap  grey32  invgrey32  colrj32  colbr32 
-                grey128  invgrey128  colrj128  colbr128 
-                red32cm  green32cm  blue32cm  yellow32cm 
-                orange32cm cyan32cm violet32cm 
+ ------------------ Graphic attribute list ------------------
+>> Colors: defcol black white grey red blue green yellow
+           magenta cyan turquoise navyblue orange siennared purple
+           limegreen gold violet violetred blueviolet darkviolet
+   or "color=name" "fgcolor=name" "bgcolor=name" ex: "color=red"
+>> Lines: defline normalline thinline thickline dashedline thindashedline
+          thickdashedline dottedline thindottedline thickdottedline
+   or "line=type,width"   ex: "line=dotted,7"
+>> Fonts:
+   > Att: deffontatt normalfont boldfont italicfont bolditalicfont 
+           smallfont smallboldfont smallitalicfont smallbolditalicfont
+           bigfont bigboldfont bigitalicfont bigbolditalicfont
+           hugefont  hugeboldfont hugeitalicfont hugebolditalicfont
+   > Names: deffont courierfont helveticafont timesfont symbolfont 
+   or "font=name,type,size"   ex: "font=courrier,bolditalic,10"
+>> Marker: dotmarker<T>  plusmarker<T>  crossmarker<T> circlemarker<T>
+           fcirclemarker<T> boxmarker<T> fboxmarker<T> trianglemarker<T>
+           ftrianglemarker<T>  starmarker<T>  fstarmarker<T>
+       with <T> = 1 3 5 7 .. 15 , Example fboxmarker5 , plusmarker9 ...
+   or "marker=type,size"   ex: "marker=plus,10"
+>> ArrowMarker: basicarrow<T>  trianglearrow<T>  ftrianglearrow<T>
+                arrowshapedarrow<T> farrowshapedarrow<T>
+       with <T> = 5 7 .. 15 , Example trianglearrow7 ...
+   or "arrow=type,size"   ex: "arrow=arrowshaped,10"
+------ Specific options for image displays:
+>> ColorTables: defcmap  grey32  invgrey32  colrj32  colbr32
+                grey128  invgrey128  colrj128  colbr128
+                red32cm  green32cm  blue32cm  yellow32cm
+                orange32cm cyan32cm violet32cm
                 midas_pastel midas_heat midas_rainbow3 midas_bluered
-                midas_bluewhite midas_redwhite 
-                multicol16 multicol64 
-   revcmap : This flag reverses ColorMap indexing 
---- For image displays:    
->> ZoomFactors      zoomxN zoomx1 zoomx2 zoomx3 ... 
-                    zoom/N zoom/2 zoom/3 zoom/4 ...
->> imagecenter=ix,iy -> Position the image in widget 
->> lut=ltyp,min,max -> Sets LUT type and min/max for image display 
-                       (ltyp=lin/log/sqrt/square) 
->> image axes configuration: invx invy exchxy 
->> Axes / Axe labels / LogScale / xylimits / defdrrect 
-   See setaxesatt command 
->> stat/nostat or stats/nostats -> Toggle statistic display flag 
->> title/notitle or tit/notit -> Toggle Auto AddTitle flag 
->> DisplayWindow: next same win stack inset 
+                midas_bluewhite midas_redwhite
+                multicol16 multicol64
+>> revcmap : reverse colorMap
+>> ZoomFactors :  zoomxN   ex: zoomx1 zoomx2 zoomx3 ...
+                  zoom/N   ex: zoom/2 zoom/3 zoom/4 ...
+>> imagecenter=ix,iy : Position the image in widget
+>> lut=ltyp,min,max : Sets LUT type and min/max
+                      (ltyp=lin/log/sqrt/square)
+>> invx,invy,exchxy : image axes configuration
+>> for Axes / Axe labels / LogScale / xylimits / defdrrect
+       see setaxesatt command
+--- General purpose options:
+>> stat,stats / nsta,nstat,nostat,nostats : Toggle statistic display
+>> title,tit / notitle,notit -> Toggle automatic title display
+>> Choose display window: next same win stack inset
+
    Related commands: setaxesatt setinsetlimits 
 \end{verbatim} 
@@ -1224,16 +1286,17 @@
   Usage: setaxesatt att_list 
 Color/Line/Font attributes and axes attributes 
->> Axes:  axesnone stdaxes=defaxes=boxaxes boxaxesgrid 
-          fineaxes fineaxesgrid centeredaxes finecenteredaxes 
-          centeredaxesgrid finecenteredaxesgrid 
-          grid nogrid labels nolabels  
-          ticks noticks minorticks nominorticks 
-          extticks intticks extintticks 
-          nbticks=X_NTicks,Y_NTicks  
-          tickslen=MajTickLenFrac,MinTickLenFrac 
+>> Axes: axesnone stdaxes=defaxes=boxaxes boxaxesgrid 
+         fineaxes fineaxesgrid centeredaxes finecenteredaxes 
+         centeredaxesgrid finecenteredaxesgrid
+         axescenter=x0,y0 (only with centered axes, default "axescenter=")
+         grid nogrid labels nolabels  
+         ticks noticks minorticks nominorticks 
+         extticks intticks extintticks 
+         nbticks=X_NTicks,Y_NTicks  
+         tickslen=MajTickLenFrac,MinTickLenFrac 
 >> Axe labels font size: fixedfontsize/autofontsize=fszf 
-          autofontsize=fsizef: Font size computed automatically 
-          fixedfontsize: Use font size attribute (BaseDrawer) 
->> LogScale : linx liny logx logy -> Lin/Log Scales for 2D plots 
+         autofontsize=fsizef: Font size computed automatically 
+         fixedfontsize: Use font size attribute (BaseDrawer) 
+>> Scale type: linx liny logx logy -> Lin/Log Scales for 2D plots 
 >> xylimits=xmin,xmax,ymin,ymax  -> Forces X-Y limits in 2-D plots 
 >> defdrrect=xmin,xmax,ymin,ymax -> Defines drawing rectangle 2-D plots 
@@ -1277,4 +1340,19 @@
 \subsection{Obj. Display} \label{ObjZZDisplay} 
 \noindent 
+\piacommand{bargraph} \label{bargraph} 
+\begin{verbatim} 
+Bar-Graph view of a sequence of values 
+ Usage: bargraph ValueVarName [gr_opt]  
+    or  bargraph ValueVarName LabelVarName ColPosVarName [gr_opt] 
+  ValueVarName,LabelVarName,ColPosVarName are PIACmd interpreter 
+     variable name (vectors) 
+ - ValueVarName: Sequence of values to be represented
+ - LabelVarName: Corresponding labels
+ - ColPosVarName: Corresponding colors or color,position pairs 
+ Use a dash (-) or ! as placeholder for LabelVarName/ColPosVarName
+ Specific graphic options: fill/nofill packfrac=value 
+    horizontalbars/verticalbars  barvaluelabel/nobarvaluelabel
+ Related commands: disp nt2d vecplot ...
+\end{verbatim} 
 \piacommand{contour} \label{contour} 
 \begin{verbatim} 
@@ -1313,5 +1391,11 @@
 Displays an object as an image 
  Usage: imag nameobj [graphic_attributes]
-  Related commands: disp surf nt2d nt3d vecplot
+  Related commands: disp imagnav surf nt2d nt3d vecplot
+\end{verbatim} 
+\piacommand{imagnav} \label{imagnav} 
+\begin{verbatim} 
+Displays an object as an image with the ImageNavigator viewer 
+Usage: imagnav nameobj [graphic_attributes]
+  Related commands: disp imag surf nt2d nt3d vecplot
 \end{verbatim} 
 \piacommand{nt2d} \label{nt2d} 
@@ -1350,4 +1434,15 @@
   Related commands: disp nt2d nt3d vecplot
 \end{verbatim} 
+\piacommand{textdrawer} \label{textdrawer} 
+\begin{verbatim} 
+Multi line text darwer 
+ Usage : textdrawer LinesVarName AttVarName [gr_opt] 
+  LinesVarName,AttVarName are PIACmd interpreter variables
+ - LinesVarName: Lines to be displayed
+ - AttVarName: Corresponding font/marker/color attributes
+ Use a dash (-) or ! as placeholder for AttVarName
+ Specific graphic options: frame/noframe
+ Related commands: disp ... 
+\end{verbatim} 
 \piacommand{vecplot} \label{vecplot} 
 \begin{verbatim} 
@@ -1455,9 +1550,21 @@
   Related commands: newvec line2nt
 \end{verbatim} 
+\piacommand{newdt} \label{newdt} 
+\begin{verbatim} 
+Creates a datatable 
+ Usage: newdt name v1:t1 v2:t2 v3:t3 .. vn:tn
+        newdt name nvar
+    vi : variable name
+    ti : variable type
+         r8,r4 for 8 and 4 bytes float
+         i8,i4 for 8 and 4 bytes signed integer
+         s for string
+  Related commands: newnt newh1d  newh2d newprof[e] newgfd
+\end{verbatim} 
 \piacommand{newgfd} \label{newgfd} 
 \begin{verbatim} 
 Creates GeneralFit Data object 
  Usage: newgfd nvar nalloc [errx(0/1)]
-  Related commands: newh1d  newh2d  newprof[e] newnt 
+  Related commands: newh1d  newh2d  newprof[e] newdt newnt 
 \end{verbatim} 
 \piacommand{newh1d} \label{newh1d} 
@@ -1465,5 +1572,5 @@
 Creates a 1D histogramm 
  Usage: newh1d name xmin xmax nbin
-  Related commands: newh2d  newprof[e] newnt  newgfd 
+  Related commands: newh2d  newprof[e] newdt newnt  newgfd 
 \end{verbatim} 
 \piacommand{newh2d} \label{newh2d} 
@@ -1471,5 +1578,5 @@
 Creates a 2D histogramm 
  Usage: newh2d name xmin xmax nbinx ymin ymax nbiny
-  Related commands: newh1d  newprof[e] newnt  newgfd 
+  Related commands: newh1d  newprof[e] newdt newnt  newgfd 
 \end{verbatim} 
 \piacommand{newmtx} \label{newmtx} 
@@ -1484,5 +1591,5 @@
  Usage: newnt name v1 v2 v3 .. vn
         newnt name nvar
-  Related commands: newh1d  newh2d newprof[e] newgfd 
+  Related commands: newdt newh1d  newh2d newprof[e] newgfd 
 \end{verbatim} 
 \piacommand{newprof} \label{newprof} 
@@ -1491,5 +1598,5 @@
  Usage: newprof name xmin xmax nbin [ymin ymax]
   Errors represent the data spread in the X bin 
-  Related commands: newh1d  newh2d newprofe newnt newgfd 
+  Related commands: newh1d  newh2d newprofe newdt newnt newgfd 
 \end{verbatim} 
 \piacommand{newprofe} \label{newprofe} 
@@ -1498,5 +1605,5 @@
  Usage: newprofe name xmin xmax nbin [ymin ymax]
   Errors represent the error on the data mean in the X bin 
-  Related commands: newh1d  newh2d newprof newnt newgfd 
+  Related commands: newh1d  newh2d newprof newdt newnt newgfd 
 \end{verbatim} 
 \piacommand{newvec} \label{newvec} 
@@ -1534,4 +1641,8 @@
 \begin{verbatim} 
 To display the Help window 
+\end{verbatim} 
+\piahelpitem{stop} \label{stop} 
+\begin{verbatim} 
+To stop (break) interpreter (PIACmd/Commander) execution
 \end{verbatim} 
 \subsection{SkyMapCmd} \label{SkyMapCmd} 
@@ -1724,4 +1835,9 @@
 FFT on a vector -> Plots power spectrum 
  Usage: fftp vecName vecFFT [graphic_att] 
+\end{verbatim} 
+\piacommand{setprjmoldefval} \label{setprjmoldefval} 
+\begin{verbatim} 
+Set default value for Molleweide projection of spherical maps (outside maps)
+ Usage: setprjmoldefval OutOfMapValue 
 \end{verbatim} 
 \subsection{pawCmd} \label{pawCmd} 
@@ -1847,11 +1963,24 @@
   Related commands: h/set/cont
 \end{verbatim} 
+\piacommand{n/merge} \label{nZmerge} 
+\begin{verbatim} 
+Merge ntuples
+ n/merge nt nt_1 nt_2 ... nt_n
+ Merge ntuples nt_i into ntuple nt
+\end{verbatim} 
+\piacommand{n/pl} \label{nZpl} 
+\begin{verbatim} 
+alias to n/plot (see n/plot)
+\end{verbatim} 
 \piacommand{n/plot} \label{nZplot} 
 \begin{verbatim} 
-Plot NTuple variables a la paw (alias n/pl)
+Plot NTuple variables "a la paw" (alias n/pl)
  n/plot nameobj.x_exp [cut] [w_exp] [loop] [gratt]
  n/plot nameobj.y_exp%x_exp [cut] [loop] [gratt]
  n/plot nameobj.z_exp%y_exp%x_exp [cut] [loop] [gratt]
         for default use ! , loop=i1[:i2[:di]]
+ for 1 dimensional (1D) projection:
+   use graphic option "keepbin" to keep previous
+   plot binning for 1D distribution
   Related commands: plot2dw plot3d
 \end{verbatim} 
@@ -1862,5 +1991,25 @@
  n/proj nameproj nameobj.y_exp%x_exp [cut] [w_exp] [loop] [gratt]
         for default use ! , loop=i1[:i2[:di]]
+ for 1 dimensional (1D) projection:
+   no display is performed if "nameproj" is an existing histogram
+   unless a graphic option "gratt" is given
   Related commands: projh1d projh2d projprof exptovec
+\end{verbatim} 
+\piacommand{n/read} \label{nZread} 
+\begin{verbatim} 
+Read columns in an ASCII file and fill a NTuple or a DataTable
+ n/read nt fascii [options] var_1,c_1 var_2,c_2 ... var_n,c_n 
+ nt : NTuple or DataTable (see options) name
+ var_i,c_i : variable name, associated column in ASCII file [0,n[
+ where [options] are:
+   "-dt": create a DataTable of double instead of a NTuple
+   "=s": separator character is 's' (could be "	")
+   "-^abcd": do not read lines beginning with string "abcd" 
+   "+^abcd": read only lines beginning with string "abcd" 
+   "-abcd": do not read lines which contain string "abcd" 
+   "+abcd": read only lines which contain string "abcd" 
+ these options may be repeated (ex: "-^abcd" "-^xyz") 
+   - in case of "do not read" options are added with logical AND 
+   - in case of "read only" options are added with logical OR 
 \end{verbatim} 
 \piacommand{n/scan} \label{nZscan} 
@@ -1902,2 +2051,8 @@
   Related commands: h/integ h/deriv v/deriv
 \end{verbatim} 
+\piacommand{v/sort} \label{vZsort} 
+\begin{verbatim} 
+Sort a vector into itself
+ v/sort namevec [+1/-1]
+ "+1" means increasing order, "-1" decreasing order
+\end{verbatim} 